/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package parser;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Set;
import java.util.SortedSet;
import java.util.TreeSet;
import static parser.Parser.computeActionTable;
import static parser.Parser.computeAllPossibleItems;
import static parser.Parser.computeGotoTable;

/**
 *
 * @author edwajohn
 */
public class Main {

  public static int runTests() throws FileNotFoundException, IOException {
    Tests tests = new Tests();

    // TODO: uncomment tests as you develop code

    //------------------------------------------------------------
    // Parser tests
    //------------------------------------------------------------
//    {
//      Parser parser = new Parser("data/Paren.cfg");
//      String datFile = "data/paren1.dat";
//      try {
//        parser.parseBottomUp(datFile);
//        System.out.println("\nSuccessfully parsed " + datFile);
//        tests.test(true);
//      } catch (ParserException ex) {
//        tests.test(false, "Should have been able to parse " + datFile + ": " + ex.getMessage());
//      }
//
//      datFile = "data/paren2.dat";
//      try {
//        parser.parseBottomUp(datFile);
//        tests.test(false, "Should not have been able to parse " + datFile);
//      } catch (ParserException ex) {
//        System.out.println("Correctly failed to parse " + datFile + ": " + ex.getMessage());
//        tests.test(true);
//      }
//
//      datFile = "data/paren3.dat";
//      try {
//        parser.parseBottomUp(datFile);
//        tests.test(false, "Should not have been able to parse " + datFile);
//      } catch (ParserException ex) {
//        System.out.println("Correctly failed to parse " + datFile + ": " + ex.getMessage());
//        tests.test(true);
//      }
//
//      datFile = "data/paren4.dat";
//      try {
//        parser.parseBottomUp(datFile);
//        System.out.println("\nSuccessfully parsed " + datFile);
//        tests.test(true);
//      } catch (ParserException ex) {
//        tests.test(false, "Should have been able to parse " + datFile + ": " + ex.getMessage());
//      }
//
//    }
//
//    {
//      Parser parser = new Parser("data/Tiny.cfg");
//      String datFile = "data/tiny1.dat";
//      try {
//        parser.parseBottomUp(datFile);
//        System.out.println("\nSuccessfully parsed " + datFile);
//        tests.test(true);
//      } catch (ParserException ex) {
//        tests.test(false, "Should have been able to parse " + datFile + ": " + ex.getMessage());
//      }
//
//      datFile = "data/tiny2.dat";
//      try {
//        parser.parseBottomUp(datFile);
//        System.out.println("\nSuccessfully parsed " + datFile);
//        tests.test(true);
//      } catch (ParserException ex) {
//        tests.test(false, "Should have been able to parse " + datFile + ": " + ex.getMessage());
//      }
//
//      datFile = "data/tiny3.dat";
//      try {
//        parser.parseBottomUp(datFile);
//        tests.test(false, "Should not have been able to parse " + datFile);
//      } catch (ParserException ex) {
//        System.out.println("Correctly failed to parse " + datFile + ": " + ex.getMessage());
//        tests.test(true);
//      }
//
//      datFile = "data/tiny4.dat";
//      try {
//        parser.parseBottomUp(datFile);
//        tests.test(false, "Should not have been able to parse " + datFile);
//      } catch (ParserException ex) {
//        System.out.println("Correctly failed to parse " + datFile + ": " + ex.getMessage());
//        tests.test(true);
//      }
//
//    }

    //------------------------------------------------------------
    // Output number of tests that succeeded
    //------------------------------------------------------------
    System.out.println(tests.getSuccesses() + "/" + tests.getN()
            + " tests succeeded");
    return tests.getFailures();
  }

  /**
   * @param args the command line arguments
   * @throws java.io.IOException
   */
  public static void main(String[] args) throws IOException {
    runTests();
  }

}
